// emacscommands.js


var isEmacsCommand = false;
var isEmacsMarkEnabled = false;


function enableMarking() {
      updateStatus("Ctrl-spacebar  Begin marking text...");
      isEmacsMarkEnabled = true;
}

// Plain Ctrl+key commands
function doEmacs(key) {

  if (isEmacsCommand) {
      return;
  }
  if (key == "g") {
      updateStatus("Operation Canceled...");
      isEmacsCommand = false;
      isEmacsMarkEnabled = false;
      var start = content.selectionStart;
      content.select();
      content.setSelectionRange(start,start);;
      return;
  }
  if (key == "a") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectBeginLine');
      } else {
          goDoCommand('cmd_beginLine');
      }
      return;
  }
  if (key == "e") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectEndLine');
      } else {
          goDoCommand('cmd_endLine');
      }
      return;
  }
  if (key == "f") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectCharNext');
      } else {
          goDoCommand('cmd_charNext');
      }
      return;
  }
  if (key == "b") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectCharPrevious');
      } else {
          goDoCommand('cmd_charPrevious');
      }
      return;
  }
  if (key == "n") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectLineNext');
      } else {
          goDoCommand('cmd_lineNext');
      }
      return;
  }
  if (key == "p") {
      if (isEmacsMarkEnabled == true) {
          goDoCommand('cmd_selectLinePrevious');
      } else {
          goDoCommand('cmd_linePrevious');
      }
      return;
  }
  if (key == "_") {
      goDoCommand('cmd_undo');
      updateStatus("Ctrl-_ Undo...");
      return;
  }

}


// commands in format C-x C-key
function doEmacsCommand(key) {
    if (key == "") {
        isEmacsCommand = true;
        updateStatus("Ctrl-x");
        return;
    }
    if (key == 'g') {
        updateStatus("Operation Canceled...");
        isEmacsCommand = false;
        isEmacsMarkEnabled = false;
        return;
    }
    if (key == 's' && isEmacsCommand == false) {
        updateStatus("Ctrl-s  Find...");
        doFindDialog();
        isEmacsCommand = false;
        return;
    }
    if (isEmacsCommand == false) {
        return;
    }

    if (key == 's') {
        updateStatus("Ctrl-x Ctrl-s  Save File...");
        save();
        isEmacsCommand = false;
        return;
    }
    if (key == 'f') {
        updateStatus("Ctrl-x Ctrl-f  Open File...");
        openFilePicker();
        isEmacsCommand = false;
        return;
    }
    if (key == 'o') {
        updateStatus("Ctrl-x Ctrl-o  Browse for File...");
        openFilePicker();
        isEmacsCommand = false;
        return;
    }
    if (key == 'w') {
        updateStatus("Ctrl-x Ctrl-w  Save As...");
        saveFilePicker();
        isEmacsCommand = false;
        return;
    }
    if (key == 'w') {
        updateStatus("Ctrl-w  Cut...");
        goDoCommand('cmd_cut');
        return;
    }
    if (key == 'c') {
        updateStatus("Ctrl-x Ctrl-c  Quit...");
        handleClose();
        isEmacsCommand = false;
        return;
    }
    return true;
}

// commands in format C-x key
function doEmacsCommandSingle(key) {
    if (isEmacsCommand != true) {
        return true;
    }
    if (key == 'g') {
        updateStatus("Operation Canceled...");
        isEmacsCommand = false;
        isEmacsMarkEnabled = false;
        return false;
    }
    if (key == 'b') {
        updateStatus("Ctrl-x b  New Document...");
        addMenuBufferItem();
        addTab();
        isEmacsCommand = false;
        return false;
    }
    if (key == 'k') {
        updateStatus("Ctrl-x k  Close Document...");
        removeMenuBufferItem();
        buildTabs();
        isEmacsCommand = false;
        return false;
    }
    if (key == 'p') {
        updateStatus("Ctrl-x p  Print Document...");
        doPrint();
        isEmacsCommand = false;
        return false;
    }
    if (key == 's') {
        updateStatus("Ctrl-x s  Find Again...");
        doFindAgain();
        isEmacsCommand = false;
        return false;
    }
    if (key == 'u') {
        updateStatus("Ctrl-x u  Undo...");
        goDoCommand("cmd_undo");
        isEmacsCommand = false;
        return false;
    }
    if (key == 'y') {
        updateStatus("Ctrl-x y  Redo...");
        goDoCommand("cmd_redo");
        isEmacsCommand = false;
        return false;
    }
    if (key == 'h') {
        updateStatus("Ctrl-x h  Select All...");
        goDoCommand('cmd_selectAll');
        isEmacsCommand = false;
        return false;
    }
    if (key == 'i') {
        updateStatus("Ctrl-x i  Insert File...");
        insertFilePicker();
        isEmacsCommand = false;
        return false;
    }
    if (key == 'x') {
        updateStatus("Ctrl-x x  Execute Command...");
        showHide('execute-command',document.getElementById('view-execute'));
        isEmacsCommand = false;
        return false;
    }

    return true;
}
