// options.js file


fontFace;
fontSize;
fontWeight;
fontColor;
fontWeight;
backgroundColor;
historyMax;
isBackupEnabled;
isSaveNagEnabled;
isOpenNewDocumentEnabled;
editorBindings;
documentType;
isAlternateSourceEnabled;
isBrowserPreviewEnabled;
isTimedRefreshEnabled;
isActivityIndicatorEnabled;
timedRefreshFrequency;
alternateBrowserSource;
refreshTimeout;
tabSize;
isCssEnabled;

function init() {
    //window.onerror=opener.dumperror;

    fontFace = opener.fontFace;
    fontSize = opener.fontSize;
    fontWeight = opener.fontWeight;
    fontColor = opener.fontColor;
    fontWeight = opener.fontWeight;
    backgroundColor = opener.backgroundColor;
    historyMax = opener.historyMax;
    isBackupEnabled = opener.isBackupEnabled;
    isSaveNagEnabled = opener.isSaveNagEnabled;
    isOpenNewDocumentEnabled = opener.isOpenNewDocumentEnabled;
    editorBindings = opener.editorBindings;
    documentType = opener.documentType;
    isAlternateSourceEnabled = opener.isAlternateSourceEnabled;
    isBrowserPreviewEnabled = opener.isBrowserPreviewEnabled;
    isTimedRefreshEnabled = opener.isTimedRefreshEnabled;
    isActivityIndicatorEnabled = opener.isActivityIndicatorEnabled;
    timedRefreshFrequency = opener.timedRefreshFrequency;
    alternateBrowserSource = opener.alternateBrowserSource;
    refreshTimeout = opener.refreshTimeout;
    tabSize = opener.tabSize;
    isCssEnabled = opener.isCssEnabled;

    window.sizeToContent();
    window.moveTo( opener.centerWindowOnScreen(document.width), opener.screenY+120 );

    // set font styles controls
    var fontColorNew = document.getElementById('color-font');
    var background = document.getElementById('color-background');
    var source = document.getElementById('alternatesource');
    if (opener.alternateBrowserSource != "") {
        source.value = opener.alternateBrowserSource;
    }
    fontColorNew.color = opener.fontColor;
    background.color = opener.backgroundColor;

    // set font size
    var fontSizeList = document.getElementById('menu-font-size');

    fontSizeList.selectedIndex = eval(fontSize)-7;

    // set font weight
    var fontWeightList = document.getElementById('menu-font-weight');
    if (fontWeight == "bold") {
        fontWeightList.selectedIndex = 1;
    } else {
        fontWeightList.selectedIndex = 0;
    }

    // set font face
    var fontFaceList = document.getElementById('menu-font-face');

    if (fontFace == "arial,helvetica,sans-serif") {
        fontFaceList.selectedIndex = 0;
    } else if (fontFace == "helvetica") {
        fontFaceList.selectedIndex = 1;
    } else if (fontFace == "times") {
        fontFaceList.selectedIndex = 2;
    } else if (fontFace == "courier") {
        fontFaceList.selectedIndex = 3;
    } else if (fontFace == "monospace") {
        fontFaceList.selectedIndex = 3;
    } else if (fontFace == "lucida") {
        fontFaceList.selectedIndex = 5;
    } else if (fontFace == "verdana") {
        fontFaceList.selectedIndex = 6;
    } else if (fontFace == "terminal") {
        fontFaceList.selectedIndex = 7;
    } else if (fontFace == "trebuchet") {
        fontFaceList.selectedIndex = 8;
    } else if (fontFace == "sans-serif") {
        fontFaceList.selectedIndex = 9;
    } else if (fontFace == "serif") {
        fontFaceList.selectedIndex = 10;
    }


    // set timed refresh
    var timedRefresh = document.getElementById('timed-refresh');
    timedRefresh.selectedIndex = eval(timedRefreshFrequency)-1;

    // set tab size
    var tabInsert = document.getElementById('tab-insert-size');
    tabInsert.selectedIndex = eval(tabSize)-1;

    // set history size
    var historyList = document.getElementById('menu-history-size');
    try {
        index = eval(historyMax)/5 - 1;
    } catch(e) {
        index = 0;
        dump(e+"error in options.js when setting historyList\n");
    }
    historyList.selectedIndex = index;

    // set editor bindings controls
    var defaultBind = document.getElementById('bindings-default');
    var emacsBind = document.getElementById('bindings-emacs');
    if (opener.editorBindings == "editordefault") {
        emacsBind.setAttribute('selected','true');
    } else {
        defaultBind.setAttribute('selected','true');
    }

    // set autobackup controls
    var backupDisabled = document.getElementById('backup-disabled');
    var backupEnabled = document.getElementById('backup-enabled');
    if (opener.isBackupEnabled == "true") {
        backupEnabled.setAttribute('selected','true');
    } else {
        backupDisabled.setAttribute('selected','true');
    }

    // set savenag controls
    var savenagDisabled = document.getElementById('savenag-disabled');
    var savenagEnabled = document.getElementById('savenag-enabled');
    if (opener.isSaveNagEnabled == "true") {
        savenagEnabled.setAttribute('selected','true');
    } else {
        savenagDisabled.setAttribute('selected','true');
    }

    // timed-refresh-enabled
    var timerDisabled = document.getElementById('timed-refresh-disabled');
    var timerEnabled = document.getElementById('timed-refresh-enabled');
    if (opener.isTimedRefreshEnabled == "true") {
        timerEnabled.setAttribute('selected','true');
    } else {
        timerDisabled.setAttribute('selected','true');
    }

    // alternate source for browser
    var sourceDisabled = document.getElementById('alternate-source-disabled');
    var sourceEnabled = document.getElementById('alternate-source-enabled');
    var source = document.getElementById('alternatesource');
    if (opener.isAlternateSourceEnabled == "true") {
        sourceEnabled.setAttribute('selected','true');
        source.removeAttribute('disabled');
        source.removeAttribute('style');
    } else {
        sourceDisabled.setAttribute('selected','true');
        source.setAttribute('disabled','true');
        source.setAttribute('style','-moz-appearance: none;');
    }

    // browser preview state
    var previewDisabled = document.getElementById('preview-disabled');
    var previewEnabled = document.getElementById('preview-enabled');
    if (opener.isBrowserPreviewEnabled == "true") {
        previewEnabled.setAttribute('selected','true');
    } else {
        previewDisabled.setAttribute('selected','true');
    }

    // activity indicator state
    var indicatorDisabled = document.getElementById('indicator-disabled');
    var indicatorEnabled = document.getElementById('indicator-enabled');
    if (opener.isActivityIndicatorEnabled == "true") {
        indicatorEnabled.setAttribute('selected','true');
    } else {
        indicatorDisabled.setAttribute('selected','true');
    }

    // document type
    var documentHtml = document.getElementById('document-html');
    var documentXhtml = document.getElementById('document-xhtml');
    if (opener.documentType == "html") {
        documentHtml.setAttribute('selected','true');
    } else {
        documentXhtml.setAttribute('selected','true');
    }

    // Css format
    var cssFormatEnabled = document.getElementById('css-format-enabled');
    var cssFormatDisabled = document.getElementById('css-format-disabled');
    if (opener.isCssEnabled == "true") {
        cssFormatEnabled.setAttribute('selected','true');
    } else {
        cssFormatDisabled.setAttribute('selected','true');
    }
}


function setOptions(){
    opener.fontFace = fontFace;
    opener.fontSize = fontSize;
    opener.fontWeight = fontWeight;
    opener.fontColor = fontColor;
    opener.fontWeight = fontWeight;
    opener.backgroundColor = backgroundColor;
    opener.historyMax = historyMax;
    opener.isBackupEnabled = isBackupEnabled;
    opener.isSaveNagEnabled = isSaveNagEnabled;
    opener.isOpenNewDocumentEnabled = isOpenNewDocumentEnabled;
    opener.editorBindings = editorBindings;
    opener.documentType = documentType;
    opener.isAlternateSourceEnabled = isAlternateSourceEnabled;
    opener.isBrowserPreviewEnabled = isBrowserPreviewEnabled;
    opener.isTimedRefreshEnabled = isTimedRefreshEnabled;
    opener.isActivityIndicatorEnabled = isActivityIndicatorEnabled;
    opener.timedRefreshFrequency = timedRefreshFrequency;
    opener.alternateBrowserSource = alternateBrowserSource;
    opener.refreshTimeout = refreshTimeout;
    opener.tabSize = tabSize;
    opener.isCssEnabled = isCssEnabled;
    opener.saveProps();
}

    // restore UI preferences
function restoreUIPrefs() {
    setViewStyle(opener.content);
    setViewStyle(opener.inputFile);
    setViewStyle(opener.command);
    setViewStyle(opener.sidebar);
}

function setViewStyle(view) {
    view.setAttribute('style',
        'font-size:'+ fontSize+
        'pt;font-family:'+fontFace+
        ';color:'+fontColor+
        ';background-color:'+backgroundColor+
        ';font-weight:'+fontWeight);
}

function setDocumentType(type) {
    documentType = type;
}

function setCssFormat(state) {
    isCssEnabled = state;
}

function setEditor(editor) {
    editorBindings = editor;
    alert("Restart Mozedit for this change to take effect.");
}

function setTabSize(size) {
    tabSize = size;
}

function setTimedRefresh(size) {
    timedRefreshFrequency = size;
}

function setTimedRefreshState(state) {
    isTimedRefreshEnabled = state;
    if (isTimedRefreshEnabled == "true") {
        opener.killRefreshTimer(); // turn off
        opener.doRefreshTimer(); // turn on
    } else {
        opener.killRefreshTimer(); // turn off
    }
}

function setFontSize(size) {
    fontSize = size;
    restoreUIPrefs();
}

function setFontFace(face) {
    fontFace = face;
    restoreUIPrefs();
}

function setFontWeight(weight) {
    fontWeight = weight;
    restoreUIPrefs();
}

function setFontColor(picker) {
    fontColor = picker.color;
    restoreUIPrefs();
}

function setBackgroundColor(picker) {
    backgroundColor = picker.color;
    restoreUIPrefs();
}

function setAlternateBrowserSource() {
    var source = document.getElementById('alternatesource').value;
    alternateBrowserSource = source;
}

function setAlternateSourceState(state) {
    isAlternateSourceEnabled = state;
    var source = document.getElementById('alternatesource');
    if ( state == "true") {
        source.removeAttribute('disabled');
        source.removeAttribute('style');
    } else {
        source.setAttribute('disabled','true');
        source.setAttribute('style','-moz-appearance:none')
    }
}

function setPreview(state) {
    isBrowserPreviewEnabled = state;
}

function setIndicatorState(state) {
    isActivityIndicatorEnabled = state;
}


function browseFilePicker() {
    var path = opener.browseFilePicker();
    var source = document.getElementById('alternatesource');

    if (path != false) {
        source.value = path;
    }
}

function setHistorySize(size) {
    historyMax = size;
}

function setAutoBackup(enabled) {
    isBackupEnabled = enabled;
}
function setSaveNag(enabled) {
    isSaveNagEnabled = enabled;
}

function restoreDefaults() {
    if (confirm("Restore all default options in Mozedit?")) {
        opener.restoreDefaults();
        opener.restoreUIPrefs();
        init();
    }
}
